import { useState } from 'react';
import Taro from '@tarojs/taro';
import del from '@/assets/icons/landlord/delete.png'
import Popup from '@/components/Popup'
import { View, Text, Image, Textarea, Label, Button } from '@tarojs/components';
import { update,deleteExtend } from '@/services/landlord'
import './style.less'

export default (props) => {
  const { item,setReset } = props
  const [eimg, seteImg] = useState(item.content)
  const handerChange = () => {
    Taro.chooseImage({
      count: 1,
      success: function (res) {
        seteImg(res.tempFilePaths[0])
        const date={
          content:res.tempFilePaths[0],
          contentType:'image'
        }
        update(item.extId,{...item,...date} )
      }
    })
  }
  const [showCutover, setShowCutover] = useState(false)
  const showText = () => {
    setShowCutover(true)
  }
  const onClose = () => {
    setShowCutover(false)
    setReset(true)
  }
  const detele = [
    {
      src: del, // icon的路径
    }
  ]
  const [content, setContent] = useState(item.content)
  const handelDelete = () => {
    deleteExtend(item.extId)
    setReset(true)
  }
  const handelDelete2 = () => {
    deleteExtend(item.extId)
    setReset(true)
  }
  const handelEdit = () => { 
    var content = document.getElementById('content').value
    setContent(content)
    const date={
      content,
      contentType:'text'
    }
    update(item.extId,{...item,...date})
    onClose()
  }
  return (
    <View id='det'>
      <Popup show={showCutover} onClose={onClose}>
        <View className='editword'>
          <View style={{ marginBottom: '25px' }}>
            <View className='rzline' /><Label className='srl mg'>修改文字</Label><View className='rzline' />
          </View>
          <View>
            <Textarea  className='storezn' value={content} id='content' />
          </View>
          <View>
            <Button className='cancel' onClick={onClose}>取消</Button>
            <Button className='btn' onClick={handelEdit}>确认修改</Button>
          </View>
        </View>
      </Popup>
      {
        item.contentType == 'image' ?
          <View>
            <mp-slideview buttons={detele} icon onbuttontap={handelDelete}>
              <Image src={eimg} mode='widthFix' style={{ width: '100%', display: 'block' }} onClick={handerChange} />
            </mp-slideview>
          </View>
          :
          item.contentType == 'text' ?
            <View>
              <mp-slideview buttons={detele} icon onbuttontap={handelDelete2}>
                <View className='storezn' onClick={showText}>{content}</View>
              </mp-slideview>
            </View>
            : null
      }
    </View>
  )
}