import withLayout from '@/layouts'
import Taro from '@tarojs/taro'
import CustomNav from '@/components/CustomNav'
import { View, Input, Button, Label, Textarea } from '@tarojs/components';
import { useEffect, useState } from "react"
import { saveRoom, getRoomDetail, updateRoom } from '@/services/landlord'
import { getExtendContent } from "@/services/home";
import { saveExtend } from '@/services/landlord'
import Popup from '@/components/Popup'
import Extend from "../../components/Extend";
import './addRoom.less'


export default withLayout((props) => {
  const { hotelId, hotelName, roomId } = props.router.params
  const [roomModel, setRoomModel] = useState({
    hotelId,
    roomName: '',
    address: '',
    location: '',
    parkingAddress: '',
    parkingLocation: '',
    wifiName: '',
    wifiPassword: '',
    weight: '',
  })
  const onRoomMap = () => {
    Taro.chooseLocation().then((res) => {
      setRoomModel({ ...roomModel, location: res.longitude + ',' + res.latitude })

    })
  }
  const onParkMap = () => {
    Taro.chooseLocation().then((res) => {
      setRoomModel({ ...roomModel, parkingLocation: res.longitude + ',' + res.latitude })

    })
  }
  const sumbit = () => {
    if (
      roomModel.roomName != '' &&
      roomModel.address != '' &&
      roomModel.location != '' &&
      roomModel.weight != ''
    ) {
      const seveices = roomId ? updateRoom : saveRoom
      seveices(roomModel, roomId).then(() => {
        Taro.showModal({
          title: roomId ? '修改成功' : '保存成功',
          showCancel: false
        }).then(() => {
          Taro.navigateBack()
        })
      })
    } else {
      Taro.showToast({
        title: '有必填项未填哦',
        icon: 'none',
      })
    }
  }
  const [extend, setExtend] = useState([]);
  useEffect(() => {
    if (roomId) {
      getRoomDetail(roomId).then((res) => {
        setRoomModel(res)
      })
    }
  }, [roomId])//这个地方写这个单词的目的是   因为编辑时roomId有可能还没加载成功
  const [reset, setReset] = useState(false)
  useEffect(() => {
    if (roomId) {
      getExtendContent('room', roomId, { pageSize: 999 }).then((res) => {
        setExtend(res.records || []);
      })
      setReset(false)
    }
  }, [reset])

  //新增文字
  const [showCutover, setShowCutover] = useState(false)
  const [cont,setcont]=useState()
  const onClose = () => {
    setShowCutover(false)
    setReset(true)
    setcont()
  }
  const handelAdd = () => {
    var content = document.getElementById('content').value
    if (content === '') {
      Taro.showToast({
        title: '您还没有添加文字哦',
        icon: 'none'
      })
      return;
    }
    const date = {
      targetId: roomId,
      targetType: 'room',
      content,
      contentType: 'text'
    }
    saveExtend(date)
    onClose()
  }
  const showText = () => {
    setShowCutover(true)
  }
  return (
    <view className='page-index'>
      <view className="index-navbar">
        <CustomNav title={hotelName} />
      </view>
      <view className='roomDetail' style={{ height: '100%', overflow: "hidden", }} >
        <scroll-view scrollY style={{ height: '100%' }}>
          <View id='det'>
            <Popup show={showCutover} onClose={onClose}>
              <View className='editword'>
                <View style={{ marginBottom: '25px' }}>
                  <View className='rzline' /><Label className='srl mg'>新增文字</Label><View className='rzline' />
                </View>
                <View>
                  <Textarea className='storezn' id='content' value={cont} placeholder='请输入准备新增的文字' />
                </View>
                <View>
                  <Button className='cancel' onClick={onClose}>取消</Button>
                  <Button className='btn' onClick={handelAdd}>确认修改</Button>
                </View>
              </View>
            </Popup>
          </View>
          <mp-form models={roomModel} >
            <mp-cells title='房屋名称' footer='' ext-class='cells' >
              <mp-cell>
                <Input style={{ fontWeight: 'bold' }} onInput={(e) => setRoomModel({ ...roomModel, roomName: e.detail.value })} value={roomModel.roomName} placeholder='请输入房屋名称（必填）' />
              </mp-cell>
            </mp-cells>
            <mp-cells title='房屋位置'>
              <mp-cell>
                <Input style={{ color: '#000', fontWeight: 'bold', marginBottom: '13px' }} onInput={(e) => setRoomModel({ ...roomModel, address: e.detail.value })} value={roomModel.address} placeholder='请输入房屋位置（必填）' />
                <Label style={{ color: '#666' }} onClick={onRoomMap}>{roomModel.location == '' ? '房间定位（必填）' : roomModel.location}</Label>
              </mp-cell>
            </mp-cells>
            <mp-cells title='停车场位置'>
              <mp-cell>
                <Input onInput={(e) => setRoomModel({ ...roomModel, parkingAddress: e.detail.value })} value={roomModel.parkingAddress} placeholder='请输入停车场位置' />
                <Label style={{ color: '#666', lineHeight: '30px' }} onClick={onParkMap}>{roomModel.parkingLocation == '' ? '停车场定位' : roomModel.parkingLocation}</Label>
              </mp-cell>
            </mp-cells>
            <mp-cells title='WiFi信息'>
              <mp-cell>
                <View style={{ color: '#666' }}>
                  <Input style={{ display: 'inline-block', background: '#fff', width: '20%' }} value='名称：' disabled /><Input style={{ display: 'inline-block', width: '80%' }} onInput={(e) => setRoomModel({ ...roomModel, wifiName: e.detail.value })} value={roomModel.wifiName} placeholder='请输入wifi名称' />
                  <Input style={{ display: 'inline-block', background: '#fff', width: '20%' }} value='密码：' disabled /><Input style={{ display: 'inline-block', width: '80%' }} onInput={(e) => setRoomModel({ ...roomModel, wifiPassword: e.detail.value })} value={roomModel.wifiPassword} placeholder='请输入wifi密码' />
                </View>
              </mp-cell>
            </mp-cells>
            <mp-cells title='权重'>
              <mp-cell>
                <input type='number' value={roomModel.weight} onInput={(e) => setRoomModel({ ...roomModel, weight: e.detail.value })} placeholder='请输入权重（必填）' />
              </mp-cell>
            </mp-cells>
            <mp-cells title='其他指引'>
              {
                extend == '' ? null :
                  <mp-cell >
                    {extend.map((item) => (
                      <Extend key={item.extId} item={item} setReset={setReset} />
                    ))}
                  </mp-cell>
              }
              <mp-cell extClass='adds'>
                <Button className='add' onClick={showText}>增加文字</Button><Button className='add'>增加图片</Button>
                <Button className='button-OK' onClick={sumbit}>确定</Button>
              </mp-cell>
            </mp-cells>
          </mp-form>
        </scroll-view>
      </view>
    </view>
  )
})